<template>
    <div class="page-container">
        <div class="video-button-container">
            <VideoButton :source="$cookies.get('platform') == 'shopify' ? 'https://carti.crisp.help/en/article/sms-campaigns-shopify-1r4fvaq/' : 'https://carti.crisp.help/en/article/sms-campaigns-wix-5y9pi5/'" />
        </div>
        <SmsCards
            :card-data="campaignCards"
            class="row"
            :loader="loading"
        />
        <div class="title-container">
            <div class="campaigns-title">
                Campaigns
            </div>
            <div class="ml-auto">
                <add-credits
                    v-if="$cookies.get('platform') === 'wix'"
                    class="add-credits-block"
                />
                <b-btn
                    class="blue-btn"
                    @click="createCampaign"
                >
                    <i class="fa fa-plus my-icon" />
                    Create new Campaign
                </b-btn>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-7">
                <div>
                    Send once off campaigns for new products, announcements and any updates that your visitors may
                    be
                    interested in!
                </div>
                <div class="subtitle">
                    *Pro-tip: Add in a special thank you discount to sweeten the deal!
                </div>
            </div>
        </div>
        
        <!--            TABLES                  -->
        <drafts-table />
        <campaigns-table />
        <histories-table />
        <!--            /TABLES                  -->
    </div>
</template>

<script>
    import SmsCards from "@/components/sms/campaigns/SmsCards";
    import currencies from "@/data/currencies.json";
    import smsCampaign from '@/mixins/sms/campaigns.service';
    import shop from "@/mixins/shop.service";
    import DraftsTable from "@/components/sms/campaigns/DraftsTable";
    import CampaignsTable from "@/components/sms/campaigns/CampaignsTable";
    import HistoriesTable from "@/components/sms/campaigns/HistoriesTable";
    import AddCredits from "@/components/pricing/AddCredits";
    import VideoButton from '@/components/header/VideoButton';

    export default {
        name: "SmsCampaignIndex",
        components: {AddCredits, SmsCards, DraftsTable, CampaignsTable, HistoriesTable, VideoButton},
        mixins: [smsCampaign, shop],
        data() {
            return {
                campaignCards: [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: 0,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Subscribers',
                        icon: 'fa fa-users',
                        salesCount: 0,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: 0,
                        salesTitle: 'Quantity'
                    }
                ],
                shop: null,
                carts: null,
                loading: true,
                helpModalId: 'HelpModalSmsCampaigns',
                currencies: currencies,
            };
        },
        computed: {
            getCurrencySign() {
                if (!this.currencies) {
                    return {
                        symbol: this.shop.payment_currency
                    };
                }
                return this.currencies[this.shop.payment_currency];
            }
        },
        created() {
            this.loadShop();
        },
        mounted() {
            this.getCampaignsCarts();
        },
        methods: {
            async loadShop() {
                this.shop = await this.getShop();
            },
            async getCampaignsCarts() {
                this.carts         = null;
                const response     = await this.getCarts();
                this.carts         = response.data.data;
                this.campaignCards = [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: this.getCurrencySign.symbol_native + this.carts.total_revenue,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Subscribers',
                        icon: 'fa fa-users',
                        salesCount: this.carts.total_subscribers,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: this.carts.total_orders,
                        salesTitle: 'Quantity'
                    }
                ];
                this.loading       = false;
            },
            async createCampaign() {
                const campaign = {
                    "is_draft":true,
                    "body_text": this.getCampaignText(),
                    "unsubscribe_text": "Unsubscribe: ",
                    "automatic_discount_value": 15,
                    "automatic_discount_enabled": true,
                    "user_timezone": this.$moment.tz.guess(),
                    "use_subscriber_timezone": false,
                };
                const res = await this.create(campaign).then((res)=> res.data.data)
                this.$router.push({name: 'sms-campaigns-edit', params: {"id": res.id, "first": true}})
            },
            getCampaignText() {
                let text = '';
                switch ($cookies.get('platform')) {
                    case 'shopify':
                        text = '{discountValue}% OFF at {siteName}, discount applied automatically. Shop now before it`s too late! {domain}';
                        break;
                    case 'wix':
                        text = '{discountValue}% OFF at {siteName}. Use code {discountCode} at checkout. Shop now before it`s too late! {domain}';
                        break;
                    default:
                        text = '{siteName} Hi there! We just wanted to noticed you about our crazy sell! Come and see! {domain}';
                        break;
                }
                return text;
            },

        }
    };
</script>
<style scoped lang="scss">


.table-title {
    font-size: 28px;
    font-weight: bold;
    margin-left: 13px;
    margin-top: 45px;
}

.row-container {
    margin-top: 40px;
}

.not-found {
    font-size: 18px;
    color: #b3b9c4;
    font-weight: 900;
    text-align: right;
}

.table-status-complete {
    color: #2BB300;
}

.not-found span {
    color: #03183B;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
}

.subtitle {
    font-size: 11px;
}

.title-container {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 25px;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        align-items: baseline;
    }
    .add-credits-block {
        margin-right: 5px;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 15px;
    }
}

.my-icon {
    color: white;
    margin-right: 8px;
    font-size: 17px;
}

.table-first-item {
    text-align: start !important;
}

.table-hover tr {
    border-bottom: 3px solid #F5F6FA;
    border-radius: 10px;
}

.table-header {
    padding: 10px;
}

.table-body {
    background: white;
    border-radius: 10px;
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}


</style>
